"""
See beCool (http://becool.info.ucl.ac.be/pub/resources/large-scale-scheduling-instances.zip)
"""

from pycsp3 import *

limit, durations, heights = data
nTasks = len(durations)

horizon = sum(durations) + 1  # Trivial upper bound on the horizon

# x[i] is the starting time of the ith task
x = VarArray(size=nTasks, dom=range(horizon))

satisfy(
    # resource cumulative constraint
    Cumulative(origins=x, lengths=durations, heights=heights) <= limit
)

minimize(
    Maximum(x[i] + durations[i] for i in range(nTasks))
)
