"""
See https://en.wikipedia.org/wiki/Boolean_Pythagorean_triples_problem
"""

from pycsp3 import *
from math import sqrt

n = data


def conflicts():
    t = []
    for i in range(1, n + 1):
        i2 = i * i
        for j in range(i + 1, n + 1):
            j2 = j * j
            s = i2 + j2
            if s > n * n:
                break
            sr = int(sqrt(s))
            if sr * sr == s:
                t.append((i, j, sr))
    return t


conflicts = conflicts()

# x[i] is 0 (resp., 1) if integer i is in part/subset 0 (resp., 1)
x = VarArray(size=n + 1, dom={0, 1})

satisfy(
    # setting an arbitrary value to integer 0
    x[0] == 0,

    # ensuring that no Pythagorean triple is present in the same part
    [NValues(x[i], x[j], x[k]) > 1 if not variant() else (x[i], x[j], x[k]) in [(0, 0, 1), (0, 1, 0), (0, 1, 1), (1, 0, 0), (1, 0, 1), (1, 1, 0)]
     for i, j, k in conflicts]
)
